#include <qlabel.h>
#include <qlayout.h>
#include <qmessagebox.h>

#include "dimdialog.h"



DimDialog::DimDialog(QWidget *parent, const char *name,
		     bool modal, WFlags f) : QDialog(parent, name, modal, f)
{
    flag = false;
    
    group = new QGroupBox ("File Dimension (x*y*z int)", this, "filedim");
    group->setColumns (5);
    
    xdim = new QLineEdit (group, "xdim");
    QLabel *help1 = new QLabel (group);
    help1->setText("*");
    ydim = new QLineEdit (group, "ydim");
    QLabel *help2 = new QLabel (group);
    help2->setText("*");
    zdim = new QLineEdit (group, "zdim");    
    
    okay = new QPushButton (this);
    okay->setText ("OK");
    cancel = new QPushButton (this);
    cancel->setText ("Cancel");
    
    QHBoxLayout *buttonlayout = new QHBoxLayout (5, "buttonlayout");
    buttonlayout->addWidget(okay);
    buttonlayout->addWidget(cancel);
    
    QVBoxLayout *layout = new QVBoxLayout (this, 5, 5, "layout");
    layout->addWidget(group);
    layout->addLayout(buttonlayout);
    
    
     connect( cancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
     connect( okay, SIGNAL( clicked() ), this, SLOT( okayAction() ) );
}


void DimDialog::okayAction()
{
    QString x, y, z;
    bool xok, yok, zok;
    int xval, yval, zval;
    
    x = xdim->text();
    y = ydim->text();
    z = zdim->text();
    
    if (x.isEmpty() || y.isEmpty() || z.isEmpty())
    {
		QMessageBox::information( this, "Depth of Field", "Please fill in all values!" );
    }
    else
    {
		xval = x.toInt(&xok , 10);
		yval = y.toInt(&yok , 10);
		zval = z.toInt(&zok , 10);
		if (!xok || !yok || !zok)
		{
			QMessageBox::information( this, "Depth of Field", "Just use Integer values!" );
		}
		else
		{
			//dim = new int[3];
			dim[0] = xval;
			dim[1] = yval;
			dim[2] = zval;
			flag = true;
			reject();
		}
    }
}


void DimDialog::getValues (int dimension [3])
{
    dimension = dim;
}
