#ifndef DITHANIMATIONEDITORIMPL_h
#define DITHANIMATIONEDITORIMPL_h

#include <qwidget.h>

#include "DithAnimationEditor.h"
#include "DithAnim_struct.h"



//! Class DithAnimationEditorImpl
/*!
    Die Klasse ist abgeleitet von DithAnimationEditor und ist f&uuml;r die Abl&auml;ufe
	im Dithering Animationsfenster zust&auml;ndig.
*/
class DithAnimationEditorImpl : public DithAnimationEditor
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. startPoint &uuml;bergibt
		die aktuellen Einstellungen f&uuml;r Dithering.
	*/
    DithAnimationEditorImpl(QWidget* parent, const char* name, DithAnim_struct startPoint);
    //! Destruktor
	~DithAnimationEditorImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck wenn der Dialog mit OK beendet wird.
	*/
	bool getExitStatus();
	//! Methode getDithAnimStruct
	/*!
		Gibt einen Array mit den Animationspunkten zur&uuml;ck.
	*/
	DithAnim_struct *getDithAnimStruct();
	//! Methode getNumbers
	/*!
		Gibt die Anzahl der Animationspunkte zur&uuml;ck.
	*/
	int getNumbers();
    
public slots:
	//! Slot deletePointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Delete Animations Punkt Button geclickt wird.
	*/
    void deletePointButtonClicked();
	//! Slot editPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Edit Animations Punkt Button geclickt wird.
	*/
	void editPointButtonClicked();
	//! Slot newPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den New Animations Punkt Button geclickt wird.
	*/
	void newPointButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Animation Button geclickt wird.
	*/
	void startAnimationButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Punkt Button geclickt wird.
	*/
	void startPointButtonClicked();
    
private:
	DithAnim_struct *anim;
	int number;
	bool exitStatus;
	int frames;
};


#endif