#ifndef FCANIM_STARTPOINTIMPL_h
#define FCANIM_STARTPOINTIMPL_h

#include <qwidget.h>

#include "FCAnim_startPoint.h"
#include "FCAnim_struct.h"


//! Class FCAnim_startPointImpl
/*!
    Diese Klasse ist abgeleitet von der Klasse FCAnim_startPoint. In ihr sind die 
	Methoden fr die Actions im Dialog ausprogrammiert.
*/
class FCAnim_startPointImpl : public FCAnim_startPoint
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. point ist eine Struktur, 
		welche den Startpunkt enth&auml;t.
	*/
    FCAnim_startPointImpl(QWidget* parent, const char* name, FCAnim_struct point);
    //! Destruktor
	~FCAnim_startPointImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck, wenn der Dialog mit OK beendet wurde.
	*/
	bool getExitStatus();
	//! Methode getFCAnimStruct
	/*!
		Gibt die neuen Werte des Startpunkts in einer Struktur zur&uuml;ck.
	*/
	FCAnim_struct getFCAnimStruct();
    
public slots:
    //! Slot xRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die x-Rotation bewegt wird.
	*/
    void xRotSliderChanged(int value);
	//! Slot yRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die y-Rotation bewegt wird.
	*/
	void yRotSliderChanged(int value);
	//! Slot zRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die z-Rotation bewegt wird.
	*/
	void zRotSliderChanged(int value);
	//! Slot zoomSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r den Zoom bewegt wird.
	*/
	void zoomSliderChanged(int value);
	//! Slot okayButtonClicked
	/*!
		Wird aufgerufen wenn der OK Button geclickt wird.
	*/
	void okayButtonClicked();
	//! Slot setFCRegionButtonClicked
	/*!
		Wird aufgerufen wenn der Focus+Context Bereichs Button geclickt wird.
	*/
	void setFCRegionButtonClicked();
    
private:
	bool getValues();
	void setValues();

	FCAnim_struct anim;
	bool exitStatus;
};


#endif