#ifndef FCANIMATIONEDITORIMPL_h
#define FCANIMATIONEDITORIMPL_h

#include <qwidget.h>

#include "FCAnimationEditor.h"
#include "FCAnim_struct.h"


//! Class FCAnimationEditorImpl
/*!
    Die Klasse ist abgeleitet von FCAnimationEditor und ist f&uuml;r die Abl&auml;ufe
	im Focus+Context Animationsfenster zust&auml;ndig.
*/
class FCAnimationEditorImpl : public FCAnimationEditor
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. startPoint &uuml;bergibt
		die aktuellen Einstellungen f&uuml;r Focus+Context.
	*/
    FCAnimationEditorImpl(QWidget* parent, const char* name, FCAnim_struct startPoint);
    //! Destruktor
	~FCAnimationEditorImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck wenn der Dialog mit OK beendet wird.
	*/
	bool getExitStatus();
	//! Methode getFCAnimStruct
	/*!
		Gibt einen Array mit den Animationspunkten zur&uuml;ck.
	*/
	FCAnim_struct *getFCAnimStruct();
	//! Methode getNumbers
	/*!
		Gibt die Anzahl der Animationspunkte zur&uuml;ck.
	*/
	int getNumbers();
    
public slots:
	//! Slot deletePointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Delete Animations Punkt Button geclickt wird.
	*/
    void deletePointButtonClicked();
	//! Slot editPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den Edit Animations Punkt Button geclickt wird.
	*/
	void editPointButtonClicked();
	//! Slot newPointButtonClicked
	/*!
		Wird aufgerufen wenn auf den New Animations Punkt Button geclickt wird.
	*/
	void newPointButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Animation Button geclickt wird.
	*/
	void startAnimationButtonClicked();
	//! Slot startAnimationButtonClicked
	/*!
		Wird aufgerufen wenn auf den Start Punkt Button geclickt wird.
	*/
	void startPointButtonClicked();
    
private:
	FCAnim_struct *anim;
	int number;
	bool exitStatus;
	int frames;
};


#endif