

#include <qwidget.h>
#include <qevent.h>
#include <qpainter.h>


//! Class focalWidget
/*!
    Diese Klasse ist abgeleitet von QWidget. Sie definiert die Abl&auml;ufe f&uuml;r 
	das Fenster in dem der Fokuspunkt dargestellt wird.
*/
class focalWidget : public QWidget
{
 Q_OBJECT
    
 public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen.
	*/
    focalWidget(QWidget * parent = 0, const char *name = 0);
	//! Destruktor
    ~focalWidget();
	//! Methode setView
	/*!
		Setzt die Parameter und die Blickrichtung der Ansicht.
	*/
    void setView(int *dimension, float *orient, double *focPoint, QString direction);
    //! Methode getFocalPoint
	/*!
		Gibt den ausgew&auml;hlten Fokuspunkt zur&uuml;ck.
	*/
	double* getFocalPoint();
    
 public slots:
	//! Slot updateFocalPoint
	/*!
		Zeichnet den Fokuspunkt neu mit dem &uuml;bergebenen Fokuspunkt.
	*/
    void updateFocalPoint(int *point);
    
 signals:
    void changeFocalPoint(int *point);
    
 protected:
    void mousePressEvent(QMouseEvent *event);
       
 private:
    void getPoints();
    void paintCube(QPainter *painter);
    void paintFocalPoint(QPainter *painter);
    void paintEvent(QPaintEvent *event);
    void getFocalPointPos();
    double getDevFactor();
	void rotatePoint(double *point, float *rotation);
	    
    int viewDirection;
    double points [8][3];
    int *dim;
    float *orientation;
    double *focalPoint;
    int *dev_focalPoint;
    bool focalPointSet;
};
