#include <iostream.h>

#include <qslider.h>

#include "FocusContextEditorImpl.h"
#include "FocusContextWidget.h"


focusContextEditorImpl::focusContextEditorImpl (QWidget *parent, const char* name, int *dimension, float *orient, double* focPoint, float *middle, float radius) : focusContextEditor (parent, name)
{
    focalPoint = new float [3];
	middlePoint = new float [3];
    orientation = new float [3];
    dim = new int [3];
    for (int i = 0; i < 3; i++)
    {
		focalPoint[i] = focPoint[i] - (double)(dimension[i])/2;
		middlePoint[i] = middle[i] - (double)(dimension[i])/2;
		orientation[i] = orient[i];
		dim[i] = dimension[i];
    }
    okay = false;
    //cout << "focal Point: " << focalPoint[0] << ", " << focalPoint[1] << ", " << focalPoint[2] << "\n";
    frontView->setView(dim, orientation, focalPoint, middlePoint, radius, "front");
    uprightView->setView(dim, orientation, focalPoint, middlePoint, radius, "upright");
	radiusSlider->setValue((int)(1000*radius/((float)dim[0]/2)));
}


focusContextEditorImpl::~focusContextEditorImpl()
{
}


void focusContextEditorImpl::okayButtonPressed()
{
    focalPoint = frontView->getFocalPoint();
    for (int i = 0; i < 3; i++)
    {
		focalPoint[i] = focalPoint[i] + (double)(dim[i])/2;
    }
	radius = frontView->getRadius();
    okay = true;
    this->close ();
}


float * focusContextEditorImpl::getFocalPoint()
{
    return focalPoint;
}


float focusContextEditorImpl::getRadius()
{
	return radius;
}
