#ifndef FOCUSCONTEXTEDITORIMPL_h
#define FOCUSCONTEXTEDITORIMPL_h

#include <qwidget.h>

#include "focusContextEditor.h"


//! Class focusContextEditorImpl
/*!
    Die Klasse ist abgeleitet von focusContextEditor und ist f&uuml;r die Abl&auml;ufe
	im Dialog zum Setzen des Focus+Context-Bereichs zust&auml;ndig.
*/
class focusContextEditorImpl : public focusContextEditor
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen.
	*/
    focusContextEditorImpl(QWidget* parent, const char* name, int *dimension, float* orient, double *focPoint, float *middle, float radius);
    //! Destruktor
	~focusContextEditorImpl();
    //! Methode getFocalPoint
	/*!
		Gibt den derzeitig ausgew&auml;hlten Fokuspunkt zur&uuml;ck.
	*/
	float* getFocalPoint();
	//! Methode getRadius
	/*!
		Gibt den Radius des gew&auml;hlten Bereichs zur&uuml;ck.
	*/
	float getRadius();

	
	/*!
		Ist true, wenn der Dialog mit OK beendet wird.
	*/
    bool okay;
    

public slots:
	//! Slot okayButtonPressed
	/*!
		Wird aufgerufen, wenn der OK Button geclickt wird.
	*/
    void okayButtonPressed();
    
private:
    float *focalPoint;
	float *middlePoint;
	float radius;
    float *orientation;
    int *dim;
};


#endif
