#include <stdlib.h>
#include <stdio.h>
#include <qregexp.h>
#include <qcolor.h>
#include <iostream.h>

#include "GOReader.h"


GOReader::GOReader(QString file)
{
    pwFunc = vtkPiecewiseFunction::New();
    filename = file;
}


GOReader::~GOReader()
{
}
    

bool GOReader::read()
{
    //cout<<"read anfang\n";
    FILE *file;
    file = fopen (filename, "rt");
    char *line = new char [256];
    bool flag = true;
    int i = 0;
    // if File could not been opened
    if (file == NULL)
    {
		return false;
    }
    // get numbers of Transfer Functions
    fgets (line, 255, file);
    QString length = line;
    int size = length.toInt(&flag);
    if (!flag)
    {
		return false;
    }
    // define array for reading Transfer Functions
    QString *string = new QString [size];
    // read line by line from file
    while (fgets (line, 255, file) != NULL && i < size)
    {
		string[i] = line;
		i++;
    }
    fclose (file);
    
    float x;
	float value;
	QRegExp rxp = QRegExp ("%", TRUE, FALSE);
    for (i = 0; i < size; i++)
    {
		flag = true;
		if (string[i].contains(rxp) != 2)
		{
			return false;
		}
		x = string[i].section(rxp, 0, 0).toFloat(&flag);
		if (!flag)
			return false;
		value = string[i].section (rxp, 1, 1).toFloat(&flag);
		if (!flag)
			return false;
		pwFunc->AddPoint(x, value);
    }
    return true;
}


vtkPiecewiseFunction* GOReader::getPiecewiseFunction()
{
    return pwFunc;
}