#ifndef MLANIM_STARTPOINTIMPL_h
#define MLANIM_STARTPOINTIMPL_h

#include <qwidget.h>

#include "MLAnim_startPoint.h"
#include "MLAnim_struct.h"


//! Class MLAnim_startPointImpl
/*!
    Diese Klasse ist abgeleitet von der Klasse MLAnim_startPoint. In ihr sind die 
	Methoden fr die Actions im Dialog ausprogrammiert.
*/
class MLAnim_startPointImpl : public MLAnim_startPoint
{
    Q_OBJECT;
    
public:
	//! Konstruktor
	/*!
		Definiert das Parent Widget und gibt dem Widget einen Namen. point ist eine Struktur, 
		welche den Startpunkt enth&auml;t.
	*/
    MLAnim_startPointImpl(QWidget* parent, const char* name, MLAnim_struct point);
    //! Destruktor
	~MLAnim_startPointImpl();
	//! Methode getExitStatus
	/*!
		Gibt true zur&uuml;ck, wenn der Dialog mit OK beendet wurde.
	*/
	bool getExitStatus();
	//! Methode getMLAnimStruct
	/*!
		Gibt die neuen Werte des Startpunkts in einer Struktur zur&uuml;ck.
	*/
	MLAnim_struct getMLAnimStruct();
    
public slots:
    //! Slot xRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die x-Rotation bewegt wird.
	*/
    void xRotSliderChanged(int value);
	//! Slot yRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die y-Rotation bewegt wird.
	*/
	void yRotSliderChanged(int value);
	//! Slot zRotSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die z-Rotation bewegt wird.
	*/
	void zRotSliderChanged(int value);
	//! Slot zoomSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r den Zoom bewegt wird.
	*/
	void zoomSliderChanged(int value);
	//! Slot okayButtonClicked
	/*!
		Wird aufgerufen wenn der OK Button geclickt wird.
	*/
	void okayButtonClicked();
	//! Slot setMLButtonClicked
	/*!
		Wird aufgerufen wenn auf den Set Magic Lamp Button geclickt wird.
	*/
	void setMLButtonClicked();
	//! Slot angleDiffSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r die Differenz des Winkels ver&auml;ndert wird.
	*/
	void angleDiffSliderChanged(int value);
	//! Slot transferFSliderChanged
	/*!
		Wird aufgerufen wenn der Slider f&uuml;r den Transfer-Koeffizienten ver&auml;ndert wird.
	*/
	void transferFSliderChanged(int value);
    
private:
	bool getValues();
	void setValues();

	MLAnim_struct anim;
	bool exitStatus;
};


#endif