// MLDirectionEditorImpl.cpp: Implementierung der Klasse MLDirectionEditorImpl.
//
//////////////////////////////////////////////////////////////////////

#include <QDial.h>

#include "MLDirectionEditorImpl.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

MLDirectionEditorImpl::MLDirectionEditorImpl(QWidget *parent, const char *name, int side, int upright) : MLDirectionEditor(parent, name)
{
	this->setCaption("Magic Lamp Direction Editor");
	ML_sideView->setValue((90+side)%360);
	ML_uprightView->setValue((180+upright)%360);
	sideDir = side;
	uprightDir = upright;
	exitStatus = false;
}


MLDirectionEditorImpl::~MLDirectionEditorImpl()
{
}


void MLDirectionEditorImpl::MLOkayButtonClicked()
{
	int help1 = ML_sideView->value() - 90;
	if (help1 < 0)
		help1 = 360 + help1;
	int help2 = ML_uprightView->value() - 180;
	if (help2 < 0)
		help2 = 360 + help2;
	
	if (help1 != sideDir || help2 != uprightDir)
	{
		uprightDir = help2;
		sideDir = help1;
		exitStatus = true;
	}
	this->close();
}


int MLDirectionEditorImpl::getSideDirection()
{
	return sideDir;
}


int MLDirectionEditorImpl::getUprightDirection()
{
	return uprightDir;
}


bool MLDirectionEditorImpl::getExitStatus()
{
	return exitStatus;
}
