#ifndef TRANSFERFUNCTION_H
#define TRANSFERFUNCTION_H


#include <qstring.h> 
#include <qcolor.h>


//! Structure transfer_element
/*!
    Ist ein Element der Transfer Functions.
*/
struct transfer_element
{
	QString name;
	QColor color;     
	float opacity;    
	float begin;     
	float length;    
	int angle_left;     
	int angle_right;
};

//! Structure transfer_function
/*!
    Struktur aller Transfer Functions in der die einzelnen Transfer Function vorkommen.
*/
struct transfer_function 
{
	transfer_element *element;     
	int length;     
	bool change; 
};
 
 

//! Class transferFunction
/*!
    Diese Klasse ist die Grundklasse der transfer Functions
*/ 
class transferFunction
{
     
public:
	//! Konstruktor
	/*!
		Default Konstruktor
	*/
	transferFunction ();
	//! Konstruktor
	/*!
		Copy Konstruktor
	*/
    transferFunction(const transferFunction &tp);
	//! Destruktor
    ~transferFunction ();
     
    //! Methode addElement
	/*!
		F&uuml;gt ein neues Element in die struct transfer_function
	*/
	void addElement (transfer_element element);
	//! Methode removeElement
	/*!
		L&ouml;scht ein Element aus der transfer_function
	*/
    void removeElement (int index);
	//! Methode getTransferFunction
	/*!
		Gibt die transfer_function zur&uuml;ck.
	*/
    transfer_function getTransferFunction ();
	//! Methode setTransferFunction
	/*!
		Setzt die transfer_function.
	*/
    void setTransferFunction (transfer_function tf);
     
    //! Struktur transfer_function
	transfer_function tf;
     
};
 
#endif // TRANSFERFUNCTION
     
